<script setup lang="ts">
import { useStockStore } from '@/stores/stock'
import { useCheckStockStore } from '@/stores/checkstock'
import { useAuthStore } from '@/stores/auth'
import { computed, nextTick, onMounted, ref, watch } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Stock } from '@/types/Stock'
import type { CheckStock } from '@/types/CheckStock'
import type { User } from '@/types/User'

const stockStore = useStockStore()
const CheckStockStore = useCheckStockStore()
const authStore = useAuthStore()
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'CheckStock Date',
    key: 'checkStockDate',
    value: 'checkStockDate'
  },
  {
    title: 'CheckStockAmount',
    key: 'checkStockAmount',
    value: 'checkStockAmount'
  },
  {
    title: 'EMP ID',
    key: 'employeeId',
    value: 'employeeId'
  },
  {
    title: 'EMP Name',
    key: 'employeeName',
    value: 'employeeName'
  },
  { title: '', key: 'actions', sortable: false }
]
const itemsPerPage = ref<any>(8)
const page = ref(1)
const pageCount = computed(() => {
  return Math.ceil(filteredCheckStock.value.length / itemsPerPage.value)
})
const tab = ref('')
const search = ref('')
const dialog = ref(false)
const refForm = ref<VForm | null>(null)
const form = ref(false)
const loading = ref(false)
const divCheckStockItems = ref<HTMLElement | null>(null)
const dialogShowCheckStockItems = ref(false)

const filteredCheckStock = computed(() => {
  const searchValue = search.value;
  const currentUser = authStore.getCurrentUser();
  const branchId = currentUser ? currentUser.branch?.id : null;

  return CheckStockStore.checkStocksData.filter((checkstock) => {
    const formattedDate = formatDate(checkstock.checkStockDate);
    const isOwner = currentUser?.roles.some((role) => role.name === 'Owner');

    if (isOwner) {
      return formattedDate.includes(searchValue);
    } else {
      const employeeBranchId = checkstock.employee?.branch?.id;
      const branchMatch = employeeBranchId === branchId;
      return formattedDate.includes(searchValue) && branchMatch;
    }
  });
});

function onSubmit() { }

function closeDialog() {
  dialog.value = false
  dialogShowCheckStockItems.value = false
  nextTick(() => {
    CheckStockStore.clearCheckStock()
    CheckStockStore.clearCheckStockItems()
  })
}

async function addCheckStockItems(s: Stock) {
  const { valid } = await refForm.value!.validate()
  CheckStockStore.addCheckStockItems(s)
  if (!valid) return
  nextTick(() => {
    if (divCheckStockItems.value)
      divCheckStockItems.value.scrollTo(0, divCheckStockItems.value.scrollHeight)
  })
}

async function showCheckStockDialog(item: CheckStock) {
  if (!item.id) return
  await CheckStockStore.getCheckStock(item.id)
  dialogShowCheckStockItems.value = true
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  if (CheckStockStore.checkStockItems.length === 0) return

  CheckStockStore.saveCheckStock()
  await stockStore.getStocks()
  filteredStock
  closeDialog()
}
const filteredStock = computed(() => {
  const currentUser = authStore.getCurrentUser()
  const currentUserRole: User | null = authStore.getCurrentUser()
  const userId = currentUser ? currentUser.branch.id : null

  return stockStore.stocks.filter((stock) => {
    const nameMatch = stock.name.toUpperCase().includes(search.value.toUpperCase())
    const branchMatch = stock.branch?.id === userId

    if (currentUserRole!.roles.some((role) => role.name === 'Owner')) return nameMatch
    else return nameMatch && branchMatch
  })
})
function formatDate(date: Date) {
  const formattedDate = new Date(date).toLocaleDateString('en-GB', {
    day: '2-digit',
    month: '2-digit',
    year: 'numeric'
  })
  return formattedDate
}

onMounted(async () => {
  await stockStore.getStocks()
  await CheckStockStore.getCheckStocks()
})
</script>

<template>
  <v-tabs v-model="tab" align-tabs="center" color="deep-purple-accent-4">
    <div>
      <v-tab style="color: black" :to="{ name: 'stock' }">Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'check-stock' }">Check Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'order-stock' }">Order Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'graph-stock' }">Graph</v-tab>
      <v-tab style="color: black" :to="{ name: 'report-stock' }">Report</v-tab>
    </div>
  </v-tabs>
  <div class="text-center">
    <h1 style="text-align: left" class="ml-5">
      <v-icon icon="mdi-text-box-check"></v-icon>Check Stock
    </h1>
  </div>
  <v-card-title class="d-flex align-center pe-2">
    <v-spacer></v-spacer>
    <v-btn style="background-color: saddlebrown; width: 200px; height: 45px" class="mr-4" @click="dialog = true">
      New Check Stock
    </v-btn>
    <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line flat
      hide-details variant="solo-filled"></v-text-field>
  </v-card-title>
  <v-data-table v-model:page="page" :headers="headers" :items="filteredCheckStock" :items-per-page="itemsPerPage">
    <template v-slot:bottom>
      <div class="text-center pt-2">
        <v-pagination v-model="page" :length="pageCount"></v-pagination>
      </div>
    </template>
    <template v-slot:[`item.checkStockDate`]="{ value }">
      {{ formatDate(value) }}
    </template>
    <template v-slot:top>
      <!--orderReceipt Dialog-->
      <v-dialog v-model="dialog" persistent width="1440" height="800">
        <v-card>
          <v-card-title class="text-h5">CheckStock Item</v-card-title>

          <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit" fast-fail class="ml-5 mr-5 mt-5">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="4">
                  <v-select v-model="CheckStockStore.editedCheckStockItem.stock" label="Please Select Stock"
                    :items="filteredStock" item-title="name" return-object>
                  </v-select>
                </v-col>
                <v-col cols="12" sm="12" md="4">
                  <v-text-field type="number" v-model.number="CheckStockStore.editedCheckStockItem.remain"
                    :readonly="loading" :rules="[(v) => v >= 0]" class="mb-2" clearable label="remain"
                    placeholder="Enter your remain"></v-text-field>
                </v-col>
              </v-row>
            </v-container>
            <v-card-actions aria-label="right">
              <v-btn style="background-color: green; width: 150px; height: 45px"
                @click="addCheckStockItems(CheckStockStore.editedCheckStockItem.stock!)">ADD</v-btn>
              <v-btn style="background-color: red; width: 150px; height: 45px"
                @click="CheckStockStore.clearCheckStockItems()">Cancel</v-btn>
            </v-card-actions>
          </v-form>

          <div ref="divCheckStockItems" style="height: 400; overflow: auto">
            <v-sheet min-width="400" max-width="1800" height="400" elevation="4">
              <v-table>
                <template v-slot:default>
                  <thead>
                    <tr>
                      <th>ID</th>
                      <th>Name</th>
                      <th>LastQuantity</th>
                      <th>Used</th>
                      <th>Remain</th>
                      <th>Action</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="(item, index) of CheckStockStore.checkStockItems" :key="item.id">
                      <td>{{ index + 1 }}</td>
                      <td>{{ item.name }}</td>
                      <td>{{ item.lastCheckQty }}</td>
                      <td>{{ item.used }}</td>
                      <td>{{ item.remain }}</td>
                      <td>
                        <v-icon size="small" @click="() => {
                          CheckStockStore.removeCheckStockItems(item)
                        }
                          ">mdi-delete</v-icon>
                      </td>
                    </tr>
                  </tbody>
                </template>
              </v-table>
            </v-sheet>
          </div>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn style="background-color: red; width: 150px; height: 45px" @click="closeDialog">
              Close
            </v-btn>
            <v-btn style="background-color: green; width: 150px; height: 45px" @click="save">
              Save
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <!-- showCheckStockItems -->
      <v-dialog v-model="dialogShowCheckStockItems" width="520" height="800" persistent>
        <v-card>
          <v-card-title class="text-h5">CheckStock Item</v-card-title>
          <div style="margin: 10px">
            <v-spacer></v-spacer>
            <td>
              วันที่สั่งสินค้า: {{ formatDate(CheckStockStore.editedCheckStock.checkStockDate) }}
            </td>
            <v-spacer></v-spacer>
            <td>ผู้ซื้อสินค้า: {{ CheckStockStore.editedCheckStock.employeeName }}</td>
            <v-spacer></v-spacer>
            <v-card-text>
              <v-table>
                <template v-slot:default>
                  <thead>
                    <tr>
                      <th>ID</th>
                      <th>Name</th>
                      <th>LastQuantity</th>
                      <th>Used</th>
                      <th>Remain</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="(item, index) of CheckStockStore.editedCheckStock.checkStockItems!" :key="item.id">
                      <td>{{ index + 1 }}</td>
                      <td>{{ item.name }}</td>
                      <td>{{ item.lastCheckQty }}</td>
                      <td>{{ item.used }}</td>
                      <td>{{ item.remain }}</td>
                    </tr>
                  </tbody>
                </template>
              </v-table>
              <br />
              <td>
                จำนวนสินค้าที่ใช้ไป: {{ CheckStockStore.editedCheckStock.checkStockAmount }} Unit
              </td>
              <v-spacer></v-spacer>
            </v-card-text>
          </div>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn style="width: 150px; height: 50px" color="red" variant="flat" @click="closeDialog">
              Close
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <template v-slot:[`item.actions`]="{ item }">
      <v-icon size="small" class="me-2" @click="showCheckStockDialog(item)">
        mdi-receipt-text</v-icon>
    </template>
  </v-data-table>
</template>

<style scoped>
.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: 'Kanit';
}

* {
  font-family: 'Kanit';
}

.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}
</style>
